#!/usr/bin/lasso9

handle_error => { stdoutnl(error_msg) }

//stdoutnl(sys_homePath)

(\net_tcp)?void // !! race condition... again

/*
	A new thread is created. This new thread is given a read/write pipe pair.
	These pipes are used to send and read messages to the calling/original thread.
	
	The original thread is converted into debugging mode. It is paused and must 
	be explicitly continued by the newly created thread.
*/
define dbgp_split(source, host, port, key) => {
	split_debugging_thread => {
		local(write, read) = #1
		local(dbg = dbgp_server(#source, #host, integer(#port), #key, #write, #read))
		protect => {
			handle => { stdoutnl(error_msg) }
			#dbg->run
		}
		sys_exit(0)
	}
}

local(source = $argv->last, host, key)

with n in 2 to $argc
let param = $argv->get(#n)
do {
	if (#param == '-d')
		#host = $argv->get(#n+1)->split(':')
	else (#param == '-k')
		#key = $argv->get(#n+1)
	/if
}

local(sourceFile = sourcefile(file(#source)))
dbgp_split(#source, #host->first, integer(#host->second), #key)

#sourceFile->invoke


